package org.processmining.acceptingpetrinetreductionlayouter.algorithms;

import java.util.ArrayList;
import java.util.Collection;

import org.processmining.acceptingpetrinetreductionlayouter.models.PlaceReduction;
import org.processmining.acceptingpetrinetreductionlayouter.models.Reduction;
import org.processmining.acceptingpetrinetreductionlayouter.workspaces.ReductionWorkspace;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;

public class PlaceFinderAlgorithm implements FinderAlgorithm {

	public Collection<Reduction> apply(ReductionWorkspace ws) {
		Collection<Reduction> reductions = new ArrayList<Reduction>();
		outerLoop: for (Place place : ws.workNet.getNet().getPlaces()) {
			for (Place otherPlace : ws.workNet.getNet().getPlaces()) {
				if (otherPlace == place) {
					continue outerLoop;
				}
				PlaceReduction reduction = new PlaceReduction();
				reduction.setPlace(place);
				reduction.setOtherPlace(otherPlace);
				if (reduction.score(ws) > 0.0) {
					reductions.add(reduction);
					if (reduction.hasOptimalScore(ws)) {
						return reductions;
					}
				}
			}
		}
		return reductions;
	}

}
