package org.processmining.acceptingpetrinetreductionlayouter.models;

import java.util.Collection;

import org.processmining.acceptingpetrinetreductionlayouter.workspaces.ReductionWorkspace;
import org.processmining.framework.util.Pair;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public interface Block {

	public int width(double hSpace);
	public int[] height();
	public int getNofLayers();
	public void doLayout(ReductionWorkspace ws, Pair<Double,Double> position, boolean isReversed, double hSpace);
	public boolean doSort(ReductionWorkspace ws);
	public Collection<PetrinetNode> getNodes(boolean addPrePost);
	public boolean doSortLoops(boolean isReversed);
	public Transition getFirstVisibleTransition(ReductionWorkspace ws);
	public Transition getLastVisibleTransition(ReductionWorkspace ws);
	public void getTransitionPairs(ReductionWorkspace ws, Collection<Pair<Transition, Transition>> pairs);
	public void doPrint(int indent);
}
