package org.processmining.acceptingpetrinetreductionlayouter.plugins;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinetreductionlayouter.algorithms.AbstractionFinderAlgorithm;
import org.processmining.acceptingpetrinetreductionlayouter.parameters.LayoutParameters;
import org.processmining.acceptingpetrinetreductionlayouter.workspaces.ReductionWorkspace;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Find abstractions", parameterLabels = { "Accepting Petri net"}, returnLabels = { "Abstraction arcs" }, returnTypes = { String.class }, userAccessible = true)
public class AbstractionFinderPlugin extends AbstractionFinderAlgorithm {

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0 })
	public String run(PluginContext context, AcceptingPetriNet net) {
		ReductionWorkspace ws = new ReductionWorkspace(net, new LayoutParameters());
		return "<html><h1>Abstractions</h1>" + apply(ws) + "</html>";
	}
}
