package org.processmining.acceptingpetrinetreductionlayouter.plugins;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinetreductionlayouter.algorithms.LayoutAlgorithm;
import org.processmining.acceptingpetrinetreductionlayouter.dialogs.LayoutDialog;
import org.processmining.acceptingpetrinetreductionlayouter.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Block Layout Accepting Petri net", parameterLabels = { "Accepting Petri net", "Parameters" }, returnLabels = {
"Net w/ Block Layout" }, returnTypes = { AcceptingPetriNet.class }, userAccessible = true)
public class LayoutAcceptingPlugin extends LayoutAlgorithm {

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0 })
	public AcceptingPetriNet runDefault(UIPluginContext context, AcceptingPetriNet net) {

		LayoutParameters parameters = new LayoutParameters();
		LayoutDialog dialog = new LayoutDialog(parameters);
		int n = 0;
		String[] title = { "Configure Block Layout" };
		InteractionResult result = InteractionResult.NEXT;
		while (result != InteractionResult.FINISHED) {
			result = context.showWizard(title[n], n == 0, n == 0, dialog.getPanel(n));
			if (result == InteractionResult.NEXT) {
				n++;
			} else if (result == InteractionResult.PREV) {
				n--;
			} else if (result != InteractionResult.FINISHED) {
				return null;
			}
		}
		
		return run(context, net, parameters);
	}

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0 })
	public AcceptingPetriNet runDefault(PluginContext context, AcceptingPetriNet net) {

		return run(context, net, new LayoutParameters());
	}

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0, 1 })
	public AcceptingPetriNet run(PluginContext context, AcceptingPetriNet net, LayoutParameters parameters) {

		return apply(context, net, parameters);
	}

}
