package org.processmining.acceptingpetrinetreductionlayouter.plugins;

import javax.swing.JComponent;

import org.processmining.acceptingpetrinetreductionlayouter.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

@Plugin(name = "Visualize Petri Net Compactly using Block Layout", level = PluginLevel.Regular, returnLabels = {
		"Compact Block Layout View on Net" }, returnTypes = {
				JComponent.class }, parameterLabels = { "Petri Net" }, userAccessible = true)
@Visualizer
public class VisualizeCompactPlugin extends AbstractVisualizePlugin {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, Petrinet net) {
		return visualize((PluginContext) context, net);
	}

	public LayoutParameters getParameters() {
		LayoutParameters parameters = new LayoutParameters();
		parameters.setHorizontalSpace(5);
		parameters.setVerticalSpace(2);
		return parameters;
	}
}
